<script src="@#file#(webgl-math.js)" type="text/javascript"></script>
<script src="@#file#(webgl-basic.js)" type="text/javascript"></script>
<script src="@#file#(webgl-view.js)" type="text/javascript"></script>
<script src="@#file#(webgl-proj.js)" type="text/javascript"></script>
<script src="@#file#(osvj.js)" type="text/javascript"></script>

<script type="text/javascript">
  var ld2 = null;

  function start() {
    ld2 = new lightningDemo('myCanvas2', 4, 1);

    ld2.scene.toggleAmbient(true);
    ld2.scene.toggleDiffuze(true);
    ld2.scene.toggleSpecular(true);

    ld2.startAnimation();
  }
</script>

  <p>
    <i>Gouraudovo sjenčanje</i> je složeniji postupak koji rezultira nešto realističnijim prikazom.
    Razmotrite oplošje kugle koje je poligonizirano određenim brojem poligona. Štoviše, neka su kao
    poligoni korišteni trokuti (pa takvu poligonizaciju nazivamo triangulacijom).
  </p>

  <p>
    Jednom kad smo oplošje podijelili na zadovoljavajuć broj trokuta, za svaki trokut imamo popis
    vrhova. Prisjetimo li se da modeliramo oplošje kugle, vrlo jednostavno možemo izračunati normalu
    na to oplošje u svakom vrhu trokuta (jer vrhovi leže na oplošju): normala će biti razlika između 
    položaja vrha i centra kugle. Primjetite: trokut koji je definiran sa svoja tri vrha sada će za svaki
    vrh znati i normalu koja pripada tom vrhu. Format OBJ koji se često koristi za zapisivanje modela
    tijela podržava i pohranu normala vrhova.
  </p>

  <p>
    Ako radimo s tijelom za koje prilikom modeliranja njegovog oplošja autor nije za svaki vrh
    pohranio pripadnu normalu, normale možemo aproksimirati. U tom slučaju, za svaki vrh analiziramo
    kojim sve trokutima pripada. Za te trokute računamo normalu ravnine u kojoj leže i potom vrhu
    dodjeljujemo aritmetičku sredinu izračunatih normala ravnina. Treba pripaziti da kod ovog postupka
    normale ravnine normaliziramo, potom izračunamo aritmetičku sredinu i tako dobivenu normalu
    ponovno normaliziramo, prije no što je pridijelimo vrhu.
  </p>

  <p>
    Pri Gouraudovom sjenčanju intenzitete računamo za svaki vrh poligona (odnosno trokuta u našem primjeru),
    koristeći, primjerice, Phongov model osvjetljavanja. Potom, kada radimo rasterizaciju algoritmom
    skenirajuće zrake, kako se pomičemo od <i>y</i><sub>min</sub> prema <i>y</i><sub>max</sub>,
    izračunate intenzitete interpoliramo po bridovima. Potom, kada smo za jednu konkretnu zraku
    <i>y</i>=<i>y</i><sub>i</sub>, odredili <i>x</i><sub>L</sub> i <i>x</i><sub>D</sub>, a te točke
    leže na bridovima, imamo interpolirani intenzitet na početku zrake (koji leži na lijevom bridu)
    i imamo interpolirani intenzitet na kraju zrake (koji leži na desnom bridu). Kako popunjavamo
    vodoravni dio zrake od <i>x</i><sub>L</sub> do <i>x</i><sub>D</sub>, intenzitet interpoliramo između
    onog s početka zrake i kraja zrake, i tim intenzitetom bojamo konkretni slikovni element (<i>x</i><sub>j</sub>,<i>y</i><sub>i</sub>).
  </p>


<figure class="mlFigure" style="margin-bottom: 20px;">
<img src="@#file#(gouraud-p.svg)">
<figcaption>Slika 1. Gouraudovo sjenčanje. Boju (intenzitete) određujemo u svim vrhovima. Uzduž osi <i>y</i> (po bridovima) interpoliramo. Za fiksni <i>y</i> slikovne elemente u unutrašnjosti interpoliramo između intenziteta na lijevom odnosno desnom bridu.
Umjesto na skali 0-1, intenzitet je računat na skali 0-255, i prikazana je samo crvena komponenta.</figcaption>
</figure>

  <p>
    Opisani postupak sjenčanja prikazan je na interaktivnoj demonstraciji u nastavku. Primjetite
    da je čitava kugla, iako sastavljena od istog broja poligona kao i kod konstantnog sjenčanja,
    sada prikazana zaglađenijom. S obzirom da se intenziteti interpoliraju po bridovima i potom po
    vodoravnoj ispuni, manje su izražene granice između susjednih poligona.
  </p>

  <p><canvas id="myCanvas2" width="640" height="480">
    Your browser doesn't appear to support the 
    &lt;canvas&gt; element.
  </canvas></p>

  <p>
    Primjetite što se događa s prikazom odbljeska. Kako se isti računa samo u vrhovima poligona
    i dalje interpolira, dobiva se skokovit prikaz.
  </p>

<script type="text/javascript">
start();
</script>

